/*
 * Copyright (C) 2006, 2007 Hewlett-Packard Development Company, L.P.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *
 ** Copyright (C) 2006, 2007 Hewlett-Packard Development Company, L.P.
 **  
 ** Authors: Simeon Pinder (simeon.pinder@hp.com), Denis Rachal (denis.rachal@hp.com), 
 ** Nancy Beers (nancy.beers@hp.com), William Reichardt 
 **
 **$Log: ServerIdentityImpl.java,v $
 **Revision 1.2  2007/05/30 20:30:28  nbeers
 **Add HP copyright header
 **
 ** 
 *
 * $Id: ServerIdentityImpl.java,v 1.2 2007/05/30 20:30:28 nbeers Exp $
 */
package com.sun.ws.management.client.impl;

import javax.xml.xpath.XPathExpressionException;

import org.w3c.dom.Document;

import com.sun.ws.management.client.ServerIdentity;
import com.sun.ws.management.client.exceptions.NoMatchFoundException;
import com.sun.ws.management.identify.Identify;

/**
 * A Wrapper for resource state that knows the xpaths for an Identify Response.
 * @author wire
 *
 */
public class ServerIdentityImpl extends ResourceStateImpl implements ServerIdentity {

	public ServerIdentityImpl(Document stateDocument) {
		super(stateDocument);
	}
	
	/* (non-Javadoc)
	 * @see com.sun.ws.management.client.impl.ServerIdentity#getBuildId()
	 */
	public String getBuildId() throws XPathExpressionException, NoMatchFoundException {
		return getWrappedValueText(Identify.BUILD_ID);
	}
	/* (non-Javadoc)
	 * @see com.sun.ws.management.client.impl.ServerIdentity#getProductVendor()
	 */
	public String getProductVendor() throws XPathExpressionException, NoMatchFoundException {
		return getWrappedValueText(Identify.PRODUCT_VENDOR);
	}
	/* (non-Javadoc)
	 * @see com.sun.ws.management.client.impl.ServerIdentity#getProductVersion()
	 */
	public String getProductVersion() throws XPathExpressionException, NoMatchFoundException {
		return getWrappedValueText(Identify.PRODUCT_VERSION);
	}
	/* (non-Javadoc)
	 * @see com.sun.ws.management.client.impl.ServerIdentity#getProtocolVersion()
	 */
	public String getProtocolVersion() throws XPathExpressionException, NoMatchFoundException {
		return getWrappedValueText(Identify.PROTOCOL_VERSION);
	}
	/* (non-Javadoc)
	 * @see com.sun.ws.management.client.impl.ServerIdentity#getSpecVersion()
	 */
	public String getSpecVersion() throws XPathExpressionException, NoMatchFoundException {
		return getWrappedValueText(Identify.SPEC_VERSION);
	}

}
